package Algorithms;

import ProblemSetUp.Problem;
import State.State;

public class BackTracking extends Algorithm {

	public BackTracking(State state, int neighbor) {
		super(state, neighbor);
		this.setFailureText("Jrglaste hulgas parema hinnanguga ja veel lbimata seisu ei ole!\n"
				+ "Juti tagasi algseisu, seega ei saa ka sammu tagasi suunas astuda!\n"
				+ "Lahendust ei leitud!");
		this.setNumber(2);
	}

	// Takes the step towards next state according to hill climbing with back
	// tracking.
	@Override
	public String getNext() {
		if (this.getSteps() < 400) {
			State<?> neighbour = this.bestNeighbor();
			if (neighbour != null
					&& this.problem.getEvaluation() > neighbour
							.findEvaluation()) {
				this.setCurrent(new Problem(neighbour, this.neighborSteps));
				this.getOpened().addAll(this.getCurrent().getNeighbors());
				this.getUsed().add(neighbour);
				this.setSteps(this.getSteps() + 1);
				return "Samm tehti parema seisu suunas!\n\n\n\n";
			} else if ((this.problem.getCurrent().getPrevious()) != null) {
				State<?> previous = this.problem.getCurrent().getPrevious();
				this.setCurrent(new Problem(previous, this.neighborSteps));
				this.setSteps(this.getSteps() + 1);
				return "Jrglaste hulgas paremat seisu ei olnud!" + '\n'
						+ "Samm tagasi!\n\n\n";
			} else
				return null;
		} else
			return null;
	}

	@Override
	public double getTemp() {
		// TODO Auto-generated method stub
		return 0;
	}

}
