package Algorithms;

import ProblemSetUp.Problem;
import State.State;

public class RandomRestart extends Algorithm {

	public RandomRestart(State state, int neighbor) {
		super(state, neighbor);
		this.setFailureText("Lahendust ei leitud!");
		this.setNumber(3);
	}

	// Takes the step towards next state according to hill climbing with random
	// restart.
	@Override
	public String getNext() {
		State<?> neighbor = this.bestNeighbor();
		if (neighbor != null
				&& this.problem.getEvaluation() > neighbor.findEvaluation()) {
			this.setCurrent(new Problem(neighbor, this.neighborSteps));
			this.getOpened().addAll(this.getCurrent().getNeighbors());
			this.getUsed().add(neighbor);
			this.setSteps(this.getSteps() + 1);
			return "Samm tehti parema seisu suunas!\n\n\n\n";
		} else {
			// State<?> random = this.chooseRandomOpened();
			// if (random == null)
			// return null;
			State<?> random = this.randomNew();
			this.setCurrent(new Problem(random, this.neighborSteps));
			this.getOpened().addAll(this.getCurrent().getNeighbors());
			this.getUsed().add(random);
			this.setSteps(this.getSteps() + 1);
			return "Jrglaste hulgas paremat seisu ei olnud!"
					+ '\n'
					+ "Genereeriti uus juhuslik algseis ning alustatakse uuesti!\n\n\n";
		}
	}

	@Override
	public double getTemp() {
		// TODO Auto-generated method stub
		return 0;
	}

}
