package Algorithms;

import ProblemSetUp.Problem;
import State.QueensState;
import State.State;

public class RegularHillClimb extends Algorithm {

	public RegularHillClimb(State state, int neighbor) {
		super(state, neighbor);
		if (problem.getCurrent().getClass() == (new QueensState()).getClass())
			this.setFailureText("Jrglaste hulgas ei ole paremat seisu! See thendab, et mistahes"
					+ '\n'
					+ "hte (kahte, kui jrglaste valik on kahe kigu kaugusel olevad seisud)"
					+ '\n'
					+ "nuppu veeru piires liigutades, ei ole vimalik saada seisu,"
					+ '\n' + "milles on konflikte vhem kui praeguses seisus.");
		else
			this.setFailureText("Jrglaste hulgas ei ole paremat seisu! See thendab,"
					+ '\n'
					+ " et mistahes suunas thja ruutu (jrglaste valikule vastav arv korda) "
					+ '\n'
					+ "liigutades, ei ole vimalik saada seisu, mille hinnang on parem"
					+ '\n' + "kui praegusel seisul.");
		this.setNumber(1);
	}

	// Takes the step towards next state according to regular hill climbing.
	@Override
	public String getNext() {
		State<?> neighbour = this.bestNeighbor();
		if (neighbour != null
				&& this.problem.getEvaluation() > neighbour.findEvaluation()) {
			this.setCurrent(new Problem(neighbour, this.neighborSteps));
			this.getOpened().addAll(this.getCurrent().getNeighbors());
			this.getUsed().add(neighbour);
			this.setSteps(this.getSteps() + 1);
			return "Samm tehti parema seisu suunas!\n\n\n\n";
		} else
			return null;
	}

	@Override
	public double getTemp() {
		return 0;
	}
}
