package GUI;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridLayout;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JLayeredPane;
import javax.swing.JPanel;

import State.PuzzleState;
import State.QueensState;

public class BoardDisplay extends JPanel {
	private static final long serialVersionUID = 1L;

	// Displaying the board for 8-puzzle
	public BoardDisplay(PuzzleState pState) {
		super(new GridLayout(3, 3));
		setMaximumSize(new Dimension(300, 300));
		int[][] state = pState.getCurrentState();
		for (int i = 0; i < 3; i++) {
			for (int j = 0; j < 3; j++) {
				JLabel label = new JLabel((state[i][j] == 0 ? "" : ""
						+ state[i][j]), JLabel.CENTER);
				label.setFont(new Font("Serif", Font.PLAIN, 50));
				label.setBorder((BorderFactory.createLineBorder(Color.black)));
				label.setBackground(new Color(144, 238, 144));
				label.setOpaque(true);
				add(label);
			}
		}
	}

	// Displaying the board for 8 queens problem
	public BoardDisplay(QueensState state) {
		Dimension boardSize = new Dimension(400, 400);
		JLayeredPane pane = new JLayeredPane();
		add(pane);
		pane.setPreferredSize(boardSize);
		JPanel board = new JPanel();
		pane.add(board, JLayeredPane.DEFAULT_LAYER);
		board.setLayout(new GridLayout(8, 8));
		board.setPreferredSize(boardSize);
		board.setBounds(0, 0, boardSize.width, boardSize.height);
		for (int i = 0; i < 8; i++) {
			for (int j = 0; j < 8; j++) {
				Tile tile;
				if (state.getCurrentState()[i][j] == 1) {
					ImageIcon icon = new ImageIcon(BoardDisplay.class
							.getClassLoader().getResource("lippv.png"));
					tile = new Tile(icon);
				} else {
					tile = new Tile();
				}

				tile.setBackground((i + j) % 2 == 0 ? Color.lightGray
						: Color.darkGray);
				board.add(tile);
			}
		}
	}
}

// Side class for displaying a tile on the chessboard
class Tile extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = 7846324475138372272L;
	ImageIcon picture;
	JLabel label;

	public Tile(ImageIcon icon) {
		this.picture = icon;
		this.label = new JLabel(picture);
		this.add(label);
	}

	public Tile() {
		this.label = new JLabel();
		this.add(label);
		this.picture = null;
	}

	public void settIcoon() {
		this.label = new JLabel();
		this.add(label);
		this.picture = null;
	}

	public void setBackground1(Color color) {
		this.setBackground(color);
	}

}
