package GUI;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JTextArea;

public class Player extends JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = 2371534411142297266L;

	public static void main(String[] args) {
		final Player mainFrame = new Player();
		final Container container = mainFrame.getContentPane();
		container.setLayout(new BoxLayout(container, BoxLayout.Y_AXIS));
		mainFrame.setSize(600, 620);
		mainFrame.setLocation(100, 100);
		mainFrame.setTitle("Mkketus");

		// Creating components for the first screen.
		JTextArea infoBox = new JTextArea(
				"Mkketusu algoritm on heuristilise otsingu algoritm. "
						+ "Alustatakse juhuslikult genereeritud algseisust, igale jrglasele antakse "
						+ "hinnangufunktsiooniga hinnang. Kui jrglasseisude hulgas leidub parema hinnanguga seis, "
						+ "siis vetakse see uueks hetkeseisuks. Algoritm jtkab, kuni hetkeseisust mingi "
						+ "operaatoriga paremat olekut vimalik saada ei ole. "
						+ '\n'
						+ '\n'
						+ "Vali probleem, mille phjal mkketusu algoritmiga tutvuda.");

		infoBox.setMaximumSize(new Dimension(400, 200));
		infoBox.setWrapStyleWord(true);
		infoBox.setLineWrap(true);
		infoBox.setEditable(false);

		final JButton backButton = new JButton("Tagasi");
		backButton.setAlignmentX(Component.CENTER_ALIGNMENT);
		backButton.setMaximumSize(new Dimension(200, 80));
		backButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				mainFrame.setTitle("Mkketus");
				mainFrame.setContentPane(container);
				mainFrame.getContentPane().revalidate();

			}
		});

		final JButton exitButton = new JButton("Vlju");
		exitButton.setAlignmentX(Component.CENTER_ALIGNMENT);
		exitButton.setMaximumSize(new Dimension(200, 80));
		exitButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				System.exit(0);

			}
		});

		JButton queensButton = new JButton("8 lipu probleem");
		queensButton.setMaximumSize(new Dimension(200, 80));
		queensButton.setAlignmentX(Component.CENTER_ALIGNMENT);
		queensButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				mainFrame.setTitle("Mkketus - 8 lipu probleem");
				mainFrame.setContentPane(new AlgorithmChoice(backButton, 1,
						null, 1));
				mainFrame.getContentPane().revalidate();

			}
		});
		JButton puzzleButton = new JButton("8-mng");
		puzzleButton.setMaximumSize(new Dimension(200, 80));
		puzzleButton.setAlignmentX(Component.CENTER_ALIGNMENT);
		puzzleButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				mainFrame.setTitle("Mkketus - 8-mng");
				mainFrame.setContentPane(new AlgorithmChoice(backButton, 2,
						null, 1));
				mainFrame.getContentPane().revalidate();

			}
		});

		// Adding components.
		container.add(infoBox);
		container.add(queensButton);
		container.add(puzzleButton);
		container.add(exitButton);

		mainFrame.setVisible(true);
		mainFrame.setDefaultCloseOperation(EXIT_ON_CLOSE);
		mainFrame.setResizable(true);
		mainFrame.setLocationRelativeTo(null);
	}
}
