package ProblemSetUp;

import java.util.HashSet;
import java.util.Set;

import State.State;

public class Problem {
	State current;
	Set<State> neighbors;
	int evaluation;

	// Constructor for setting up the problem.
	public Problem(State state, int neighborSteps) {
		this.current = state;
		if (neighborSteps == 1)
			this.neighbors = new HashSet<State>(state.findNeighbors(state));
		else if (neighborSteps == 2)
			this.neighbors = new HashSet<State>(
					state.findNeighborsTwoSteps(state));
		else if (neighborSteps == 6)
			this.neighbors = new HashSet<State>(state.findNeighborsSixSteps());
		this.evaluation = state.findEvaluation();
	}

	public State getCurrent() {
		return current;
	}

	public void setCurrent(State current) {
		this.current = current;
	}

	public int getEvaluation() {
		return evaluation;
	}

	public void setEvaluation(int evaluation) {
		this.evaluation = evaluation;
	}

	public Set<State> getNeighbors() {
		return neighbors;
	}

}
