package State;

public class QueensEvaluation {

	public static int evaluate(QueensState state) {
		return conflictingPairs(state.getCurrentState());
	}

	// // Calculating conflicts based on rows.
	// public static int rowCheck(int[][] state) {
	// int sum = 0;
	// for (int i = 0; i < 8; i++) {
	// int abi = 0;
	// for (int j : (state[i]))
	// abi += j;
	// if (abi > 0)
	// sum += (abi - 1);
	// }
	// return sum;
	// }
	//
	// // Calculating conflicts on diagonals.
	// public static int diagCheck(int[][] matrix) {
	// int sum = 0;
	// for (int i = 0; i < 8; i++) {
	// int a = i;
	// int b = 0;
	//
	// int sum1 = 0;
	// int sum2 = 0;
	// int sum3 = 0;
	// int sum4 = 0;
	// while (a < 8 && b < 8) {
	// sum1 += matrix[a][b];
	// if (a != b) {
	// sum2 += matrix[b][a];
	// }
	// a += 1;
	// b += 1;
	// }
	// if (sum1 > 0) {
	// sum += (sum1 - 1);
	// }
	// if (sum2 > 0) {
	// sum += (sum2 - 1);
	// }
	// a = i;
	// int d = 7;
	// while (a < 8 && d >= 0) {
	// sum3 += matrix[a][d];
	// a++;
	// d--;
	// }
	//
	// if (sum3 > 0)
	// sum += (sum3 - 1);
	// a = i;
	// b = 0;
	// while (b < 8 && a >= 0 && a < 7) {
	// sum4 += matrix[b][a];
	// b++;
	// a--;
	// }
	// if (sum4 > 0)
	// sum += (sum4 - 1);
	//
	// }
	// return sum;
	// }

	// Method for calculating the number of queen pairs that are attacking each
	// other.
	public static int conflictingPairs(int[][] matrix) {
		int sum = 0;
		for (int i = 0; i < 8; i++) {
			for (int j = 0; j < 8; j++) {
				if (matrix[i][j] == 1) {
					sum += sameDiag(matrix, i, j);
					sum += sameRow(matrix[i], j);
				}
			}
		}
		return sum;
	}

	public static int sameRow(int[] row, int column) {
		int sum = 0;
		for (int i = column + 1; i < 8; i++) {
			sum += row[i];
		}
		return sum;
	}

	public static int sameDiag(int[][] matrix, int row, int column) {
		int sum = 0;
		int col1 = column;
		int col2 = column;
		for (int i = row + 1; i < 8; i++) {
			if (col1 < 7) {
				col1++;
				sum += matrix[i][col1];
			}
			if (col2 > 0) {
				col2--;
				sum += matrix[i][col2];
			}
		}
		return sum;
	}

}
